<script lang="ts" setup>
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Member } from '@/types/Member'
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'
import memberService from '@/service/member'
import { useMemberStore } from '@/stores/member'
import { useTypeStore } from '@/stores/type'
const memberStore = useMemberStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Point',
    key: 'point',
    value: 'point'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const typeStore = useTypeStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const members = ref<Member[]>([])

let editedIndex = -1
let lastId = 4
function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    memberStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await memberStore.deleteMember()
  closeDelete()
}
async function editItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialog.value = true
}
async function deleteItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    memberStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await memberStore.saveMember()
  closeDialog()
}

onMounted(async () => {
  await memberStore.getMembers()
  await typeStore.getTypes()
})

const search = ref<string>('')

const formattedMembers = computed(() =>
  memberStore.members.map((members) => ({
    ...members
  }))
)

const filteredMembers = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedMembers.value.filter((member) => member.tel.toLowerCase().includes(searchLower))
})

const page = ref(1)
const itemsPerPage = ref<any>(5)
const pageCount = computed(() => {
  return Math.ceil(memberStore.members.length / itemsPerPage.value)
})
</script>

<template>
  <div>
    <v-row>
      <v-col cols="12" sm="12">
        <h style="font-size: 50px"><v-icon icon="mdi-account" class="mr-5"></v-icon>Member</h>
      </v-col>
      <v-col cols="12" sm="6">
        <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line
          flat hide-details variant="solo-filled"></v-text-field>
      </v-col>
      <!-- edited dialog and new member -->
      <v-col cols="12" sm="6">
        <v-dialog v-model="dialog" persistent width="600">
          <template v-slot:activator="{ props }">
            <v-btn color="success" v-bind="props">New Member</v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span>Member Profile</span>
            </v-card-title>
            <v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <v-text-field v-model="memberStore.editedMember.name" :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Name"
                        variant="outlined"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-text-field v-model="memberStore.editedMember.tel" :readonly="loading" :rules="[
                        (v) => !!v || 'Field is Field is required',
                        (v) => (v && v.length === 10) || 'Tel. number must be 10 digits',
                        (v) => /^\d+$/.test(v) || 'Tel. number must contain only digits'
                      ]" class="mb-2" clearable label="Tel." placeholder="Enter your tel."
                        variant="outlined"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-text-field :readonly="loading" :rules="[(v) => !!v || 'Field is required']" class="mb-2"
                        clearable label="Password" variant="outlined"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-text-field v-model.number="memberStore.editedMember.point" :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Point"
                        variant="outlined"></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-col>
    </v-row>
    <v-data-table v-model:page="page" :headers="headers" :items="filteredMembers" :items-per-page="itemsPerPage">
      <template v-slot:bottom>
        <div class="text-center pt-2">
          <v-pagination v-model="page" :length="pageCount"></v-pagination>
        </div>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil</v-icon>
        <v-icon size="small" @click="deleteItem(item)" class="mr-2"> mdi-delete </v-icon>
      </template>
    </v-data-table>
    <v-dialog v-model="dialogDelete" max-width="500px">
      <v-card>
        <v-card-title class="font ma-4 pt-6" style="text-align: center">you want to delete this info? 🗑️</v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
            @click="closeDelete">Cancel</v-btn>
          <v-spacer></v-spacer>
          <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
            @click="deleteItemConfirm">OK</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<style scoped>
div {
  font-family: 'Kanit';
}
</style>
computed,
